--------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.Std_Logic_1164.all;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ENTITY Configurable_U12 IS
  PORT(
      DA : IN std_logic_vector(6 downto 0) :=(OTHERS => 'U');
      DB : IN std_logic_vector(6 downto 0) :=(OTHERS => 'U');
      DC : IN std_logic_vector(6 downto 0) :=(OTHERS => 'U');
      DD : IN std_logic_vector(6 downto 0) :=(OTHERS => 'U');
      Y : OUT std_logic_vector(6 downto 0) :=(OTHERS => '0');
      S : IN std_logic_vector(1 downto 0) :=(OTHERS => 'U')
  );
END Configurable_U12;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ARCHITECTURE structure OF Configurable_U12 IS
BEGIN
    PROCESS(DA, DB, DC, DD, S)
    BEGIN
        CASE S IS
            WHEN "00" =>
                Y <= DA;
            WHEN "01" =>
                Y <= DB;
            WHEN "10" =>
                Y <= DC;
            WHEN "11" =>
                Y <= DD;
            WHEN OTHERS =>
                Y <= (OTHERS => '0');
        END CASE;
    END PROCESS;
END structure;
--------------------------------------------------------------------------------
