--------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.Std_Logic_1164.all;
USE IEEE.Std_Logic_Unsigned.all;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ENTITY Configurable_U499 IS
  PORT(
      Q0   : OUT std_logic;
      Q1   : OUT std_logic;
      CLR  : IN  std_logic;
      CEO  : OUT std_logic;
      TC   : OUT std_logic;
      CE   : IN  std_logic;
      C    : IN  std_logic
  );
END Configurable_U499;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ARCHITECTURE structure OF Configurable_U499 IS
--------------------------------------------------------------------------------
CONSTANT cMaxValue : std_logic_vector(1 downto 0) := "11";
CONSTANT cMinValue : std_logic_vector(1 downto 0) := (OTHERS => '0');
SIGNAL Y : std_logic_vector(1 downto 0) := cMaxValue;
SIGNAL TC_int: std_logic;
--------------------------------------------------------------------------------
BEGIN
    PROCESS(C, CLR)
    BEGIN
        IF CLR = '1' THEN
            Y <= cMaxValue;
        ELSIF C'Event and C = '1' THEN
            IF (CE = '1') THEN
                IF Y <= cMinValue THEN
                    Y <= cMaxValue;
                ELSE
                    Y <= Y - 1;
                END IF;
            END IF;
        END IF;
    END PROCESS;
    TC_int <= '1' WHEN (Y = cMinValue) ELSE
              '0';
    Q0 <= Y(0);
    Q1 <= Y(1);
    TC <= TC_int;
    CEO <= TC_int AND CE;
END structure;
--------------------------------------------------------------------------------
